#Adjusted R-square after McElree, using fixed effects and random effects (level 1)

Rsquared <- function(model, observed) {
SSR <- sum(residuals(model,level=1)^2)
SS <- sum((observed - mean(observed))^2)
N <- model$dims$N
fixedparms <- length(model$coefficients$fixed)
randparms <- model$dims$qvec[1]
#parms = fixedparms + randparms + randparms*(randparms-1)/2 + 1

a <- VarCorr(model)
aa <- as.numeric(a)
covar <- 0
for (b in 1:length(aa))
  if (is.na(aa[b]) == F) covar <- covar+1
# computes the number of numerical entries in the variance-covariance matrix
covar <- covar - 2*randparms - 2 
# subtract the number of Stds and Variances (2*randparms) and the 2 entries for the residuals
parms <- fixedparms + randparms + covar
#means + variances + covariances

rsq = 1 - (SSR/(N-parms))/(SS/(N-1)) 
Rsquared = c(rsq, parms)
}



