#Function for plotting means with 95% CI, offset by off on the x-axis
#data = dataset
#varvector = vector of the numbers of the variables to be plotted
#groupvector = vector of categories on the x axis to which the variables are assigned
#off = offset of data points relative to category values in groupvector

plot.confint <- function(data, varvector, groupvector, off, upper=T, lower=T,
         xlim=c(groupvector[1]-0.5, groupvector[length(groupvector)]+0.5),...) 
{
data <- as.matrix(data[,varvector])
#m <- mean(data)
#std <- sd(data)
m <- colMeans(data, na.rm=TRUE)
#std <- sapply(data, sd, na.rm=TRUE)
std <- apply(data, 2, sd, na.rm=TRUE)
ci <- 1.96*std/sqrt(length(t(data[,1])))    #t = transpose
if (upper==T) uiw <-ci else uiw <- 0
if (lower==T) liw <-ci else liw <- 0
x <- groupvector+off
#xlim <- c(groupvector[1]-0.5, groupvector[length(groupvector)]+0.5) 
plot(x,m,xlim=xlim, type="b", ...)
plotCI(x,m,uiw=uiw,liw=liw,xlim=xlim, gap=0.3, add=TRUE, ...) 
#plot(x,m, type="b", ...)
#plotCI(x,m,uiw=uiw,liw=uiw,gap=0.3, add=TRUE, ...)
}